Custom Editors

Although the FlexGrid control provides efficient, Excel-style editing by default, you may want to customize the editing experience by using custom editors.

This is easily done by assigning an instance of an editor control to the column's editor property. This sample demonstrates this using Wijmo's InputDate, InputTime, ComboBox, AutoComplete, MultiSelect, InputMask, InputColor and InputNumber controls.

Learn about FlexGrid | FlexGrid Documentation | FlexGrid API Reference

app.js
index.html
data.js
styles.css
Copy to CodeMine
import 'bootstrap.css'; import '@mescius/wijmo.styles/wijmo.css'; import './styles.css'; import { FlexGrid, DataMap } from '@mescius/wijmo.grid'; import { InputDate, InputTime, InputNumber, InputColor, ComboBox, AutoComplete, InputMask, MultiSelect } from '@mescius/wijmo.input'; import { getData, getCountries, getProducts, getNames } from './data'; document.readyState === 'complete' ? init() : window.onload = init; function init() { // create a grid with custom editors new FlexGrid('#theGrid', { showMarquee: true, selectionMode: 'MultiRange', alternatingRowStep: 0, autoGenerateColumns: false, columns: [ { header: 'ID', binding: 'id', width: 80, isReadOnly: true }, { header: 'Date', binding: 'date', format: 'd', editor: new InputDate(document.createElement('div')) }, { header: 'Time', binding: 'time', format: 't', editor: new InputTime(document.createElement('div'), { isEditable: true, format: 't', step: 30 }) }, { header: 'Country', binding: 'country', editor: new ComboBox(document.createElement('div'), { itemsSource: getCountries() }) }, { header: 'Product', binding: 'productId', dataMap: new DataMap(getProducts(), 'id', 'name'), editor: new AutoComplete(document.createElement('div'), { itemsSource: getProducts(), selectedValuePath: 'id', displayMemberPath: 'name' }) }, { header: 'Names', binding: 'name', width: 250, editor: new MultiSelect(document.createElement('div'), { itemsSource: getNames(), showSelectAllCheckbox: true }) }, { header: 'Phone', binding: 'phone', editor: new InputMask(document.createElement('div'), { mask: '(000) 000-0000' }) }, { header: 'Color', binding: 'color', cellTemplate: '<span class="colorbox" style="background:${text};"></span> ${text}', editor: new InputColor(document.createElement('div')) }, { header: 'Amount', binding: 'amount', format: 'n2', editor: new InputNumber(document.createElement('div'), { format: 'n2', step: 10, min: 0, max: 10000 }) }, { header: 'Premium', binding: 'premium', cssClass: 'switch' } ], itemsSource: getData() }); }
import 'bootstrap.css'; import '@mescius/wijmo.styles/wijmo.css'; import './styles.css'; import { FlexGrid, DataMap } from '@mescius/wijmo.grid'; import { InputDate, InputTime, InputNumber, InputColor, ComboBox, AutoComplete, InputMask, MultiSelect } from '@mescius/wijmo.input'; import { getData, getCountries, getProducts, getNames } from './data'; document.readyState === 'complete' ? init() : window.onload = init; function init() { // create a grid with custom editors new FlexGrid('#theGrid', { showMarquee: true, selectionMode: 'MultiRange', alternatingRowStep: 0, autoGenerateColumns: false, columns: [ { header: 'ID', binding: 'id', width: 80, isReadOnly: true }, { header: 'Date', binding: 'date', format: 'd', editor: new InputDate(document.createElement('div')) }, { header: 'Time', binding: 'time', format: 't', editor: new InputTime(document.createElement('div'), { isEditable: true, format: 't', step: 30 }) }, { header: 'Country', binding: 'country', editor: new ComboBox(document.createElement('div'), { itemsSource: getCountries() }) }, { header: 'Product', binding: 'productId', dataMap: new DataMap(getProducts(), 'id', 'name'), editor: new AutoComplete(document.createElement('div'), { itemsSource: getProducts(), selectedValuePath: 'id', displayMemberPath: 'name' }) }, { header: 'Names', binding: 'name', width: 250, editor: new MultiSelect(document.createElement('div'), { itemsSource: getNames(), showSelectAllCheckbox: true }) }, { header: 'Phone', binding: 'phone', editor: new InputMask(document.createElement('div'), { mask: '(000) 000-0000' }) }, { header: 'Color', binding: 'color', cellTemplate: '<span class="colorbox" style="background:${text};"></span> ${text}', editor: new InputColor(document.createElement('div')) }, { header: 'Amount', binding: 'amount', format: 'n2', editor: new InputNumber(document.createElement('div'), { format: 'n2', step: 10, min: 0, max: 10000 }) }, { header: 'Premium', binding: 'premium', cssClass: 'switch' } ], itemsSource: getData() }); }
<!DOCTYPE html> <html lang="en"> <head> <meta charset="utf-8"> <meta http-equiv="X-UA-Compatible" content="IE=edge"> <title>MESCIUS Wijmo FlexGrid Custom Editors</title> <meta name="viewport" content="width=device-width, initial-scale=1.0"> <!-- SystemJS --> <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app'); </script> </head> <body> <div class="container-fluid"> <div id="theGrid"></div> </div> </body> </html>
export function getData(cnt = 100) { var data = [], countries = getCountries(), products = getProducts(), dt = new Date(), names = getNames(), yr = dt.getFullYear(); for (var i = 0; i < cnt; i++) { data.push({ id: i, date: new Date(yr, i % 12, 25, i % 24, i % 60, i % 60), time: new Date(yr, i % 12, 25, i % 24, i % 60, i % 60), country: pickOne(countries), productId: pickOne(products).id, name: [pickOne(names), pickOne(names)], phone: "(" + generateNumber(100, 999) + ") " + generateNumber(100, 999) + "-" + generateNumber(1000, 9999), color: pickOne('Red,Green,Blue,Yellow,Pink,Orange,Gold'.split(',')), amount: Math.random() * 10000, discount: Math.random() / 4, premium: Math.random() > .8 }); } return data; } export function getCountries() { return 'US,Germany,UK,Japan,Italy,Greece'.split(','); } export function getProducts() { let p = 'Andy Capp\'s fries,Barcel,Brannigans,Bugles,Cape Cod Potato Chips,Cheese Flavoured Moments,' + 'Cheetos,Cheez Doodles,Cheez-It,Cheezies,CornNuts,David Sunflower Seeds,Doritos,Frazzles,Frito-Lay,' + 'Fritos,Golden Wonder,Hula Hoops,Kettle Foods,KP Nuts,Kurkure,Lay\'s Stax,McCoys Crisps,' + 'Monster Munch,Munchos,Nobby\'s Nuts,Phileas Fogg,Pirate\'s Booty,Pringles,Ringos,Ruffles,' + 'Salt\'n\' Shake,San Nicasio,Space Raiders,Sun Chips,Smith\'s Crisps,Tudor Crisps,Twiglets,' + 'Twisties,Tyrrells,Tyrrells Apple Chips,Walkers Crisps,Wheat Crunchies,Wise Foods,Wotsits'; return p.split(',').map((name, id) => { return { id: id, name: name }; }); } export function getNames() { return 'Aaron Smith,Paul Johnson,John Richards,Mark Bannon,Sue Wong'.split(','); } function pickOne(arr) { return arr[Math.floor(Math.random() * arr.length)]; } function generateNumber(min, max) { return Math.floor(Math.random() * (max - min + 1)) + min; }
body { margin-bottom: 24px; } .wj-flexgrid { height: 300px; margin-bottom: 12px; } .wj-flexgrid .wj-cell { padding: 6px 8px; } .colorbox { display: inline-block; width: 12px; height: 1.5em; margin: 0 3px 0 -3px; border: 1px solid black; vertical-align: bottom; } /* switch-style checkbox */ .wj-cell.switch input[type=checkbox] { opacity: 0; width: 100%; } .wj-cell.switch label { width: 3em; position: relative; } .wj-cell.switch input[type=checkbox]+span { pointer-events: none; background: rgba(0, 0, 0, 0.4); } .wj-cell.switch input[type=checkbox]:checked+span { background: #0085c7; /* rgb(27, 255, 27) */ } .wj-cell.switch:hover input[type=checkbox]+span:after { box-shadow: 0 3px 3px rgba(0, 0, 0, 0.4); transition: all 0.3s; } .wj-cell.switch input[type=checkbox]+span:before { content: ''; position: absolute; display: block; left: 0; top: .45em; width: 2.5em; height: .75em; border-radius: 1em; background: rgba(0, 0, 0, .4); opacity: .25; } .wj-cell.switch input[type=checkbox]:checked+span:before { background: inherit; } .wj-cell.switch input[type=checkbox]+span:after { content: ''; position: absolute; left: 0; top: 0.13em; width: 1.3em; height: 1.3em; background: white; border-radius: 1em; border: 1px solid rgba(0, 0, 0, .2); box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2); } .wj-cell.switch input[type=checkbox]:checked+span:after { left: 1.25em; transition: all 0.3s; background: inherit; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'jszip': 'npm:jszip/dist/jszip.js', '@mescius/wijmo': 'npm:@mescius/wijmo/index.js', '@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js', '@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles', '@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures', '@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js', '@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js', '@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js', '@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js', '@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js', '@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js', '@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js', '@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js', '@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js', '@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js', '@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js', '@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js', '@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js', '@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js', '@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js', '@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js', '@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js', '@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js', '@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js', '@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js', '@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js', '@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js', '@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js', '@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js', '@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js', '@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js', '@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js', '@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js', '@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js', '@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js', '@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js', '@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js', '@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js', '@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js', '@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js', '@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js', '@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js', '@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js', '@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js', '@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js', '@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js', '@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js', '@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js', 'jszip': 'npm:jszip/dist/jszip.js', 'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import '@angular/compiler';
import { Component, enableProdMode, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import {
InputDate,
InputTime,
ComboBox,
AutoComplete,
InputNumber,
InputColor,
MultiSelect,
InputMask,
} from '@mescius/wijmo.input';
import { DataMap } from '@mescius/wijmo.grid';
import { getData, getCountries, getProducts, getNames } from './data';
@Component({
standalone: true,
imports: [WjGridModule, WjInputModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
data = getData();
countries = getCountries();
products = getProducts();
productMap = new DataMap(this.products, 'id', 'name');
names = getNames();
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Custom Editors</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<main class="container-fluid">
<!-- grid with custom editors -->
<wj-flex-grid
selectionMode="MultiRange"
[showMarquee]="true"
[alternatingRowStep]="0"
[(itemsSource)]="data">
<wj-flex-grid-column binding="id" header="ID" [width]="80" [isReadOnly]="true"></wj-flex-grid-column>
<wj-flex-grid-column binding="date" header="Date" format="d"
[editor]="theInputDate">
</wj-flex-grid-column>
<wj-flex-grid-column binding="time" header="Time" format="t"
[editor]="theInputTime">
</wj-flex-grid-column>
<wj-flex-grid-column binding="country" header="Country" [dataMap]="countries"
[editor]="theCountryCombo">
</wj-flex-grid-column>
<wj-flex-grid-column binding="productId" header="Product" [dataMap]="productMap"
[editor]="theProductAutoComplete">
</wj-flex-grid-column>
<wj-flex-grid-column binding="name" header="Names" [width]="250"
[editor]="theNamesMultiSelect">
</wj-flex-grid-column>
<wj-flex-grid-column binding="phone" header="Phone"
[editor]="thePhoneInputMask">
</wj-flex-grid-column>
<wj-flex-grid-column binding="color" header="Color"
cellTemplate="<span class=colorbox style=background:${text}></span> ${text}"
[editor]="theInputColor">
</wj-flex-grid-column>
<wj-flex-grid-column binding="amount" header="Amount" format="n2"
[editor]="theInputNumber">
</wj-flex-grid-column>
<wj-flex-grid-column binding="premium" header="Premium" cssClass="switch"></wj-flex-grid-column>
</wj-flex-grid>
<!-- custom editors -->
<wj-input-date #theInputDate></wj-input-date>
<wj-input-time #theInputTime
[isEditable]="true"
[step]="30">
</wj-input-time>
<wj-combo-box #theCountryCombo [itemsSource]="countries"></wj-combo-box>
<wj-auto-complete #theProductAutoComplete
[itemsSource]="products"
selectedValuePath="id"
displayMemberPath="name">
</wj-auto-complete>
<wj-multi-select #theNamesMultiSelect
[itemsSource]="names"
[showSelectAllCheckbox]="true">
</wj-multi-select>
<wj-input-mask #thePhoneInputMask
[mask]="'(000) 000-0000'">
</wj-input-mask>
<wj-input-color #theInputColor></wj-input-color>
<wj-input-number #theInputNumber
format="n2"
[step]="10"
[min]="0"
[max]="10000">
</wj-input-number>
</main>
body {
margin-bottom: 24px;
overflow: hidden;
}
.wj-flexgrid {
height: 300px;
margin-bottom: 12px;
}
.wj-flexgrid .wj-cell {
padding: 6px 8px;
}
.colorbox {
display: inline-block;
width: 12px;
height: 1.5em;
margin: 0 3px 0 -3px;
border: 1px solid black;
vertical-align: bottom;
}
/* switch-style checkbox */
.wj-cell.switch input[type=checkbox] {
opacity: 0;
width: 100%;
}
.wj-cell.switch label {
width: 3em;
position: relative;
}
.wj-cell.switch input[type=checkbox]+span {
pointer-events: none;
background: rgba(0, 0, 0, 0.4);
}
.wj-cell.switch input[type=checkbox]:checked+span {
background: #0085c7; /* rgb(27, 255, 27) */
}
.wj-cell.switch:hover input[type=checkbox]+span:after {
box-shadow: 0 3px 3px rgba(0, 0, 0, 0.4);
transition: all 0.3s;
}
.wj-cell.switch input[type=checkbox]+span:before {
content: '';
position: absolute;
display: block;
left: 0;
top: .45em;
width: 2.5em;
height: .75em;
border-radius: 1em;
background: rgba(0, 0, 0, .4);
opacity: .25;
}
.wj-cell.switch input[type=checkbox]:checked+span:before {
background: inherit;
}
.wj-cell.switch input[type=checkbox]+span:after {
content: '';
position: absolute;
left: 0;
top: 0.13em;
width: 1.3em;
height: 1.3em;
background: white;
border-radius: 1em;
border: 1px solid rgba(0, 0, 0, .2);
box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);
}
.wj-cell.switch input[type=checkbox]:checked+span:after {
left: 1.25em;
transition: all 0.3s;
background: inherit;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<main class="container-fluid">
<wj-flex-grid :alternatingRowStep="0" :showMarquee="true" selectionMode="MultiRange" :itemsSource="data">
<wj-flex-grid-column binding="id" header="ID" :width="80" :isReadOnly="true" />
<wj-flex-grid-column binding="date" header="Date" format="d" :editor="editors.inputDate" />
<wj-flex-grid-column binding="time" header="Time" format="t" :editor="editors.inputTime" />
<wj-flex-grid-column binding="country" header="Country" :editor="editors.countryCombo" />
<wj-flex-grid-column binding="productId" header="Product" :dataMap="productMap"
:editor="editors.productAutoComplete" />
<wj-flex-grid-column binding="name" header="Names" :width="250"
:editor="editors.namesMultiSelect" />
<wj-flex-grid-column binding="phone" header="Phone"
:editor="editors.phoneInputMask" />
<wj-flex-grid-column binding="color" header="Color"
cellTemplate="<span class='colorbox' style='background:${text}'></span> ${text}"
:editor="editors.inputColor" />
<wj-flex-grid-column binding="amount" header="Amount" format="n2" :editor="editors.inputNumber" />
<wj-flex-grid-column binding="premium" header="Premium" cssClass="switch" />
</wj-flex-grid>
</main>
</template>
<script setup>
import * as wjcCore from "@mescius/wijmo";
import { InputDate, InputTime, ComboBox, AutoComplete, InputColor, InputNumber, MultiSelect, InputMask } from "@mescius/wijmo.input";
import { DataMap } from "@mescius/wijmo.grid";
import { getData, getCountries, getProducts, getNames } from "./data";
import { ref } from "vue";
const data = ref(getData());
const countries = ref(getCountries());
const products = ref(getProducts());
const productMap = ref(new DataMap(getProducts(), "id", "name"));
const editors = ref({
inputDate: new InputDate(document.createElement("div")),
inputTime: new InputTime(document.createElement("div"), {
isEditable: true,
format: "t",
step: 30,
}),
countryCombo: new ComboBox(document.createElement("div"), {
itemsSource: getCountries(),
}),
productAutoComplete: new AutoComplete(document.createElement("div"), {
itemsSource: getProducts(),
selectedValuePath: "id",
displayMemberPath: "name",
}),
namesMultiSelect: new MultiSelect(document.createElement("div"), {
itemsSource: getNames(),
showSelectAllCheckbox: true,
}),
phoneInputMask: new InputMask(document.createElement("div"), {
mask: "(000) 000-0000",
}),
inputColor: new InputColor(document.createElement("div")),
inputNumber: new InputNumber(document.createElement("div"), {
format: "n2",
step: 10,
min: 0,
max: 10000,
}),
});
</script>
<style>
body {
margin-bottom: 24px;
overflow: hidden;
}
.wj-flexgrid {
height: 300px;
margin-bottom: 12px;
}
.wj-flexgrid .wj-cell {
padding: 6px 8px;
}
.colorbox {
display: inline-block;
width: 12px;
height: 1.5em;
margin: 0 3px 0 -3px;
border: 1px solid black;
vertical-align: bottom;
}
/* switch-style checkbox */
.wj-cell.switch input[type=checkbox] {
opacity: 0;
width: 100%;
}
.wj-cell.switch label {
width: 3em;
position: relative;
}
.wj-cell.switch input[type=checkbox]+span {
pointer-events: none;
background: rgba(0, 0, 0, 0.4);
}
.wj-cell.switch input[type=checkbox]:checked+span {
background: #0085c7;
/* rgb(27, 255, 27) */
}
.wj-cell.switch:hover input[type=checkbox]+span:after {
box-shadow: 0 3px 3px rgba(0, 0, 0, 0.4);
transition: all 0.3s;
}
.wj-cell.switch input[type=checkbox]+span:before {
content: '';
position: absolute;
display: block;
left: 0;
top: .45em;
width: 2.5em;
height: .75em;
border-radius: 1em;
background: rgba(0, 0, 0, .4);
opacity: .25;
}
.wj-cell.switch input[type=checkbox]:checked+span:before {
background: inherit;
}
.wj-cell.switch input[type=checkbox]+span:after {
content: '';
position: absolute;
left: 0;
top: 0.13em;
width: 1.3em;
height: 1.3em;
background: white;
border-radius: 1em;
border: 1px solid rgba(0, 0, 0, .2);
box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);
}
.wj-cell.switch input[type=checkbox]:checked+span:after {
left: 1.25em;
transition: all 0.3s;
background: inherit;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Custom Editors</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
export function getData(cnt = 100) {
var data = [], countries = getCountries(),
products = getProducts(), names = getNames(), dt = new Date(), yr = dt.getFullYear();
for (var i = 0; i < cnt; i++) {
data.push({
id: i,
date: new Date(yr, i % 12, 25, i % 24, i % 60, i % 60),
time: new Date(yr, i % 12, 25, i % 24, i % 60, i % 60),
country: pickOne(countries),
productId: pickOne(products).id,
name: [pickOne(names), pickOne(names)],
phone: "(" + generateNumber(100, 999) + ") " + generateNumber(100, 999) + "-" + generateNumber(1000, 9999),
color: pickOne('Red,Green,Blue,Yellow,Pink,Orange,Gold'.split(',')),
amount: Math.random() * 10000,
discount: Math.random() / 4,
premium: Math.random() > .8
});
}
return data;
}
export function getCountries() {
return 'US,Germany,UK,Japan,Italy,Greece'.split(',');
}
export function getProducts() {
let p = 'Andy Capp\'s fries,Barcel,Brannigans,Bugles,Cape Cod Potato Chips,Cheese Flavoured Moments,' +
'Cheetos,Cheez Doodles,Cheez-It,Cheezies,CornNuts,David Sunflower Seeds,Doritos,Frazzles,Frito-Lay,' +
'Fritos,Golden Wonder,Hula Hoops,Kettle Foods,KP Nuts,Kurkure,Lay\'s Stax,McCoys Crisps,' +
'Monster Munch,Munchos,Nobby\'s Nuts,Phileas Fogg,Pirate\'s Booty,Pringles,Ringos,Ruffles,' +
'Salt\'n\' Shake,San Nicasio,Space Raiders,Sun Chips,Smith\'s Crisps,Tudor Crisps,Twiglets,' +
'Twisties,Tyrrells,Tyrrells Apple Chips,Walkers Crisps,Wheat Crunchies,Wise Foods,Wotsits';
return p.split(',').map((name, id) => {
return { id: id, name: name };
});
}
export function getNames() {
return 'Aaron Smith,Paul Johnson,John Richards,Mark Bannon,Sue Wong'.split(',');
}
function pickOne(arr) {
return arr[Math.floor(Math.random() * arr.length)];
}
function generateNumber(min, max) {
return Math.floor(Math.random() * (max - min + 1)) + min;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React from 'react';
import { FlexGrid, FlexGridColumn } from '@mescius/wijmo.react.grid';
import { DataMap } from '@mescius/wijmo.grid';
import { InputDate, InputTime, ComboBox, AutoComplete, InputColor, InputNumber, InputMask, MultiSelect } from '@mescius/wijmo.input';
import './app.css';
import { data, countries, products, names } from './data';
function App() {
return (<main className="container-fluid">
<FlexGrid showMarquee={true} alternatingRowStep={0} selectionMode="MultiRange" itemsSource={data}>
<FlexGridColumn binding="id" header="ID" width={80} isReadOnly={true}/>
<FlexGridColumn binding="date" header="Date" format="d" editor={new InputDate(document.createElement('div'))}/>
<FlexGridColumn binding="time" header="Time" format="t" editor={new InputTime(document.createElement('div'), {
format: 't',
step: 30
})}/>
<FlexGridColumn binding="country" header="Country" editor={new ComboBox(document.createElement('div'), {
itemsSource: countries
})}/>
<FlexGridColumn binding="productId" header="Product" dataMap={new DataMap(products, 'id', 'name')} editor={new AutoComplete(document.createElement('div'), {
itemsSource: products,
selectedValuePath: 'id',
displayMemberPath: 'name'
})}/>
<FlexGridColumn binding="name" header="Names" width={250} editor={new MultiSelect(document.createElement('div'), {
itemsSource: names,
showSelectAllCheckbox: true
})}/>
<FlexGridColumn binding="phone" header="Phone" editor={new InputMask(document.createElement('div'), {
mask: '(000) 000-0000'
})}/>
<FlexGridColumn binding="color" header="Color" cellTemplate='<span class="colorbox" style="background:${text};"></span> ${text}' editor={new InputColor(document.createElement('div'))}/>
<FlexGridColumn binding="amount" header="Amount" format="n2" editor={new InputNumber(document.createElement('div'), {
format: 'n2',
step: 10,
min: 0,
max: 10000
})}/>
<FlexGridColumn binding="premium" header="Premium" cssClass="switch"/>
</FlexGrid>
</main>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexGrid Custom Editors</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
body {
margin-bottom: 24px;
overflow: hidden;
}
.wj-flexgrid {
height: 300px;
margin-bottom: 12px;
}
.wj-flexgrid .wj-cell {
padding: 6px 8px;
}
.colorbox {
display: inline-block;
width: 12px;
height: 1.5em;
margin: 0 3px 0 -3px;
border: 1px solid black;
vertical-align: bottom;
}
/* switch-style checkbox */
.wj-cell.switch input[type=checkbox] {
opacity: 0;
width: 100%;
}
.wj-cell.switch label {
width: 3em;
position: relative;
}
.wj-cell.switch input[type=checkbox]+span {
pointer-events: none;
background: rgba(0, 0, 0, 0.4);
}
.wj-cell.switch input[type=checkbox]:checked+span {
background: #0085c7;
/* rgb(27, 255, 27) */
}
.wj-cell.switch:hover input[type=checkbox]+span:after {
box-shadow: 0 3px 3px rgba(0, 0, 0, 0.4);
transition: all 0.3s;
}
.wj-cell.switch input[type=checkbox]+span:before {
content: '';
position: absolute;
display: block;
left: 0;
top: .45em;
width: 2.5em;
height: .75em;
border-radius: 1em;
background: rgba(0, 0, 0, .4);
opacity: .25;
}
.wj-cell.switch input[type=checkbox]:checked+span:before {
background: inherit;
}
.wj-cell.switch input[type=checkbox]+span:after {
content: '';
position: absolute;
left: 0;
top: 0.13em;
width: 1.3em;
height: 1.3em;
background: white;
border-radius: 1em;
border: 1px solid rgba(0, 0, 0, .2);
box-shadow: 0 2px 2px rgba(0, 0, 0, 0.2);
}
.wj-cell.switch input[type=checkbox]:checked+span:after {
left: 1.25em;
transition: all 0.3s;
background: inherit;
}
export function getData(cnt = 100) {
var data = [], countries = getCountries(), products = getProducts(), names = getNames(), dt = new Date(), yr = dt.getFullYear();
for (var i = 0; i < cnt; i++) {
data.push({
id: i,
date: new Date(yr, i % 12, 25, i % 24, i % 60, i % 60),
time: new Date(yr, i % 12, 25, i % 24, i % 60, i % 60),
country: pickOne(countries),
productId: pickOne(products).id,
name: [pickOne(names), pickOne(names)],
phone: "(" + generateNumber(100, 999) + ") " + generateNumber(100, 999) + "-" + generateNumber(1000, 9999),
color: pickOne('Red,Green,Blue,Yellow,Pink,Orange,Gold'.split(',')),
amount: Math.random() * 10000,
discount: Math.random() / 4,
premium: Math.random() > .8
});
}
return data;
}
export function getCountries() {
return 'US,Germany,UK,Japan,Italy,Greece'.split(',');
}
export function getProducts() {
let p = 'Andy Capp\'s fries,Barcel,Brannigans,Bugles,Cape Cod Potato Chips,Cheese Flavoured Moments,' +
'Cheetos,Cheez Doodles,Cheez-It,Cheezies,CornNuts,David Sunflower Seeds,Doritos,Frazzles,Frito-Lay,' +
'Fritos,Golden Wonder,Hula Hoops,Kettle Foods,KP Nuts,Kurkure,Lay\'s Stax,McCoys Crisps,' +
'Monster Munch,Munchos,Nobby\'s Nuts,Phileas Fogg,Pirate\'s Booty,Pringles,Ringos,Ruffles,' +
'Salt\'n\' Shake,San Nicasio,Space Raiders,Sun Chips,Smith\'s Crisps,Tudor Crisps,Twiglets,' +
'Twisties,Tyrrells,Tyrrells Apple Chips,Walkers Crisps,Wheat Crunchies,Wise Foods,Wotsits';
return p.split(',').map((name, id) => {
return { id: id, name: name };
});
}
export function getNames() {
return 'Aaron Smith,Paul Johnson,John Richards,Mark Bannon,Sue Wong'.split(',');
}
function pickOne(arr) {
return arr[Math.floor(Math.random() * arr.length)];
}
function generateNumber(min, max) {
return Math.floor(Math.random() * (max - min + 1)) + min;
}
export const data = getData();
export const countries = getCountries();
export const products = getProducts();
export const names = getNames();
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);